/*
  YAKS, a Khepera simulator including a separate GA and ANN 
  (Genetic Algoritm, Artificial Neural Net).
  Copyright (C) 2000  Johan Carlsson (johanc@ida.his.se)
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 */

#include "buildn.h"
#include "param.h"

void feedforward(Ann *orginal, int inputs){
  int i;
   for(i=0; i < inputs; i++)
      orginal->addNeuron(0,INPUT,SIGMOID);
   for(i=0; i < 2; i++)
     orginal->addNeuron(5,OUTPUT,SIGMOID);
   orginal->connectLayer(0,5);
}

void elman(Ann *orginal, int inputs){
   //Ann *orginal;
   int i;
   //orginal = new Ann();
   for(i=0; i < inputs; i++)
      orginal->addNeuron(0,INPUT,SIGMOID);
   for(i=0; i < hiddenNeurons; i++)
     orginal->addNeuron(5,INTERN,SIGMOID);
   for(i=0; i < 4; i++)
     orginal->addNeuron(10,OUTPUT,SIGMOID);
   
   orginal->connectLayer(0,5);
   orginal->connectLayer(5,5);
   orginal->connectLayer(5,10);
}

void elman2(Ann *orginal, int inputs){
   //Ann *orginal;
   int i;
   //orginal = new Ann();
   for(i=0; i < inputs; i++)
      orginal->addNeuron(0,INPUT,SIGMOID);
   for(i=0; i < hiddenNeurons; i++)
     orginal->addNeuron(5,INTERN,SIGMOID);
   for(i=0; i < 4; i++)
     orginal->addNeuron(10,OUTPUT,SIGMOID);
   
   orginal->connectLayer(0,5);
   orginal->connectLayer(5,5);
   orginal->connectLayer(5,10);
   orginal->connectLayer(0,10);
}

FB *buildNetwork[NETWORKS]= {elman,
			     elman};


