#ifndef CALLBACKS_H
#define CALLBACKS_H

#include <pthread.h>
#include <gtk/gtk.h>

#include "support.h"


typedef enum {BTRUE=1,BFALSE=0}BOOL_T;
typedef enum {WHEEL,ARROW,DOT}BOT_T;

#ifdef WIN32
extern HANDLE simAreaUpdate_S;
extern HANDLE simArea_S;
#else
#include <semaphore.h>
extern sem_t simAreaUpdate_S;
extern sem_t simArea_S;
#endif

extern BOOL_T robotBody;
extern BOT_T robotType;
extern int gui_stepping;
extern int sensorAreaVisible;
extern GtkWidget *simArea;
extern GtkWidget **simRobots;
extern GdkPixmap *bb_simArea;   /* simArea backbuffer */
extern GdkPixmap *bg_simArea;   /* simArea background */
extern GdkPixmap **bb_simRobots;/* simRobots backbuffer */
extern GdkGC **internal_blit_simRobots;
extern GdkColormap *cm_simArea; /* simArea colormap   */
extern GdkColor **pal_simArea;  /* simArea colors     */
extern GdkFont *defaultFont;
extern GdkGC *pen_simArea;
extern GdkGC *blit_simArea;
extern gint colors;
extern gint definedColors;
extern gushort pal[6][3];
extern int sim_area_x_size;
extern int sim_area_y_size;

void gui_init();

void on_button_clicked(GtkButton       *button,
		       gpointer         user_data);

void on_button_clicked(GtkButton       *button,
		       gpointer         user_data);

void on_run_btn_clicked(GtkButton       *button,
			gpointer         user_data);

void on_paus_btn_clicked(GtkButton       *button,
			 gpointer         user_data);

void on_step_btn_clicked(GtkButton       *button,
			 gpointer         user_data);

void on_snapshot_btn_clicked(GtkButton *button,
			     gpointer  user_data);
void on_evolution_tgl_toggled(GtkToggleButton *togglebutton,
			      gpointer         user_data);

void on_wheel_rbtn_toggled(GtkToggleButton *togglebutton,
			   gpointer         user_data);

void on_arrow_rbtn_toggled(GtkToggleButton *togglebutton,
			   gpointer         user_data);

void on_body_tgl_toggled(GtkToggleButton *togglebutton,
			 gpointer         user_data);

void on_trace_tgl_toggled(GtkToggleButton *togglebutton,
			  gpointer         user_data);

void on_refresh_btn_clicked(GtkButton       *button,
			    gpointer         user_data);

void on_draw_tgl_toggled(GtkToggleButton *togglebutton,
			 gpointer         user_data);
void on_generation_next_btn_clicked(GtkToggleButton *togglebutton,
                                    gpointer         user_data);
void guiCreateSensorArea(int nrOfSensors, int heightPerSensor, int historyLength);
void guiDefineColours();
void sensorM_activate();
void simAreaM_activate();
void gfxUserM_activate();
void gui_setWorldSize(int x, int y);
#endif
