/*
  YAKS, a Khepera simulator including a separate GA and ANN 
  (Genetic Algoritm, Artificial Neural Net).
  Copyright (C) 2000  Johan Carlsson (johanc@ida.his.se)
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
#ifndef MONITOR_H
#define MONITOR_H
#include <stdio.h>
#include <stdlib.h>
#include "value.h"
#include "param.h"
#include <world.h>


class Monitor{
 public:
  Monitor(int iWW,int iWH, int pens);
  ~Monitor();
  void addWatch(const char *title, const double min, const double max);
  //  void addButton(const char *title, (void*)(GtkWidget*,gpointer data));
  void setValue(int watchNr, double value);
  void createWindow();
  void drawValues();
  void toggleRuler();
  void useNextPen();
  void setWatch(int index, double val);
  void setPen(int pen,int color);
  void setRuler(int color);
  void setBorder(int color);
  void setText(int color);
 private:
  Value **watch; 
  yWindow *display;
  int nrOfWatches;
  int timeStep;
  int wH;  /* height for window */
  int wW;  /* window width, history */
  int colorRuler;
  int colorBG;
  int colorPen;
  int *pen;
  int nrOfPens;
  int colorBorder;
  int colorText;
  int rulers;
};

#endif /* MONITOR_H */
