/*
  YAKS, a Khepera simulator including a separate GA and ANN 
  (Genetic Algoritm, Artificial Neural Net).
  Copyright (C) 2000  Johan Carlsson (johanc@ida.his.se)
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
#include "value.h"
#include <glib.h>
Value::Value(const char *iTitle, double iMin, double iMax){
  description = NULL;
  min = iMin;
  max = iMax;
  if(iTitle)
    description = g_strdup(iTitle);
  value = min;
}

Value::~Value(){
  if(description)
    free(description);
}

double Value::getVal() const{
  if(value > max)
    return(max);
  if(value < min)
    return(min);
  return(value);
}
double Value::getNormal()const{
  double tmp = getVal();
  if(max - min != 0){
    tmp = (tmp-min) / (max-min);
  }else{
    tmp = 0.0;
  }
  return(tmp);
}
double Value::getReal() const{
  return(value);
}
char *Value::getDescription()const{
  return description;
}

void Value::setVal(double iN){
  value = iN;
}
