#include "callbacks.h"
#include "world.h"
#include <geom.h>
#include <param.h>
#include <gdk/gdk.h>
#ifdef HAVE_IMLIB
#include <gdk_imlib.h>
#endif
#include <param.h>
#include <time.h>

#define GUI_UPDATE(x) if(gfxUpdate){ x }

void gui_draw_text(GdkPixmap *p,GdkGC *pen, gint x, gint y, const gchar *text){
  gdk_draw_text(p,
		defaultFont,
		pen,
		x,y,
		text,
		strlen(text));
}


void gui_drawSensor(GdkPixmap *p,GdkGC *pen, int xs, int ys, double value, int w){
  gdk_gc_set_foreground(internal_blit_simRobots[0],
			pal_simArea[(63 - (int)(value * 63.0)) + 6]
			);
  gdk_draw_rectangle(p,
                     pen,
                     1,
                     (gint)(xs - w),(gint)(ys - w),
		     w*2,w*2);
}

void gui_updateSensorWindow(int robotNr,int useRodSensorF,int useEnergyF){
  int w;
  gchar text[5];
  GdkGC *pen;
  gdk_threads_enter();
  pen = internal_blit_simRobots[robotNr];
  gdk_gc_set_foreground(pen,
			pal_simArea[GUI_WHITE]
			);
  gdk_draw_rectangle(bb_simRobots[robotNr],
		     pen,
		     1,
		     0,0,
		     51,90);
  
  gdk_gc_set_foreground(pen,
			pal_simArea[(robotNr%GUI_COLORS) + 1]
			);
  gdk_draw_arc(bb_simRobots[robotNr],
	       pen,
	       0,
	       0,0,
	       50,50,
	       0,360*64);
  g_snprintf(text,5,"%d",robotNr);

  gui_draw_text(bb_simRobots[robotNr],
		pen,
		21,28,
		text);
		

  w=3;
  gui_drawSensor(bb_simRobots[robotNr],pen,5,20,simoutput[robotNr][0],w);
  gui_drawSensor(bb_simRobots[robotNr],pen,13,10,simoutput[robotNr][1],w);
  gui_drawSensor(bb_simRobots[robotNr],pen,20,5,simoutput[robotNr][2],w);
  gui_drawSensor(bb_simRobots[robotNr],pen,30,5,simoutput[robotNr][3],w);
  gui_drawSensor(bb_simRobots[robotNr],pen,37,10,simoutput[robotNr][4],w);
  gui_drawSensor(bb_simRobots[robotNr],pen,45,20,simoutput[robotNr][5],w);
  gui_drawSensor(bb_simRobots[robotNr],pen,20,40,simoutput[robotNr][7],w);
  gui_drawSensor(bb_simRobots[robotNr],pen,30,40,simoutput[robotNr][6],w);

  if(useRodSensorF){
    w=(int)(50/ROD_RESOLUTION);
    gdk_gc_set_foreground(pen,
			  pal_simArea[GUI_BLACK]
			  );
    gdk_draw_rectangle(bb_simRobots[robotNr],
		       pen,
		       1,
		       0,60,
		       50,10);
    gdk_gc_set_foreground(pen,
			  pal_simArea[GUI_BLUE]
			  );
    for(int i=0; i < ROD_RESOLUTION; i++){
      if(simoutput[robotNr][RodSensor+i] > 0.0 ){
	gdk_draw_rectangle(bb_simRobots[robotNr],
			   pen,
			   1,
			   w*i,60,
			   w,10);
      }
    } 
  } 
  if(useEnergyF){
    gdk_gc_set_foreground(pen,
			  pal_simArea[GUI_GREEN]
			  );
    gdk_draw_rectangle(bb_simRobots[robotNr],
		       pen,
		       1,
		       0,73,
		       (int)(50*simoutput[robotNr][EnergySensor]),83);
  }
  gdk_threads_leave();
}
#ifndef OPENGL
void gui_drawRobot(int x, int y, double direction, int radius, int layer, int color,int usesRodSensor){
  int x2,y2;
  float aL;

  gdk_threads_enter();
  gdk_gc_set_foreground(pen_simArea,
			pal_simArea[(color%GUI_COLORS) + 1]
			);
  if(layer==2){
    if(robotType==1){
      x2=(int)(x+radius*cos(g_DGRtoRAD(direction)));
      y2=(int)(y+radius*sin(g_DGRtoRAD(direction)));
      
      gdk_draw_line(bg_simArea,pen_simArea,x,y,
	    x2,y2);
      aL=radius*0.8;
      gdk_draw_line(bg_simArea,pen_simArea,x2,y2,
	      (int)(x+aL*cos(g_DGRtoRAD(direction-15))),
	      (int)(y+aL*sin(g_DGRtoRAD(direction-15))));
      gdk_draw_line(bg_simArea,pen_simArea,x2,y2,
	      (int)(x+aL*cos(g_DGRtoRAD(direction+15))),
	      (int)(y+aL*sin(g_DGRtoRAD(direction+15))));
      if(usesRodSensor){
	gdk_draw_line(bg_simArea,pen_simArea,x,y,
		      (int)(x+xScale*ROD_MAX_DISTANCE*cos(g_DGRtoRAD(direction-(int)(ROD_ANGLE/2)))),
		      (int)(y+xScale*ROD_MAX_DISTANCE*sin(g_DGRtoRAD(direction-(int)(ROD_ANGLE/2)))));
	gdk_draw_line(bg_simArea,pen_simArea,x,y,
		      (int)(x+xScale*ROD_MAX_DISTANCE*cos(g_DGRtoRAD(direction+(int)(ROD_ANGLE/2)))),
		      (int)(y+xScale*ROD_MAX_DISTANCE*sin(g_DGRtoRAD(direction+(int)(ROD_ANGLE/2)))));
      }
    }
    else{
      gdk_draw_line(bg_simArea,pen_simArea,(int)(x+radius*cos(g_DGRtoRAD(direction-90))),
	      (int)(y+radius*sin(g_DGRtoRAD(direction-90))),
	      (int)(x+radius*cos(g_DGRtoRAD(direction+90))),
	      (int)(y+radius*sin(g_DGRtoRAD(direction+90))));
    }
    if(robotBody){
      gdk_draw_arc(bg_simArea,
		   pen_simArea,
		   0,
		   x-radius,y-radius,
		   2*radius,2*radius,
		   0,360*64);
    }
  }
  else{
    if(robotType==1){
      x2=(int)(x+radius*cos(g_DGRtoRAD(direction)));
      y2=(int)(y+radius*sin(g_DGRtoRAD(direction)));

      gdk_draw_line(bb_simArea,pen_simArea,x,y,
	    x2,y2);
      aL=radius*0.8;
      gdk_draw_line(bb_simArea,pen_simArea,x2,y2,
	      (int)(x+aL*cos(g_DGRtoRAD(direction-15))),
	      (int)(y+aL*sin(g_DGRtoRAD(direction-15))));
      gdk_draw_line(bb_simArea,pen_simArea,x2,y2,
	      (int)(x+aL*cos(g_DGRtoRAD(direction+15))),
	      (int)(y+aL*sin(g_DGRtoRAD(direction+15))));
      if(usesRodSensor){
	gdk_draw_line(bb_simArea,pen_simArea,x,y,
		      (int)(x+xScale*ROD_MAX_DISTANCE*cos(g_DGRtoRAD(direction-(int)(ROD_ANGLE/2)))),
		      (int)(y+xScale*ROD_MAX_DISTANCE*sin(g_DGRtoRAD(direction-(int)(ROD_ANGLE/2)))));
	gdk_draw_line(bb_simArea,pen_simArea,x,y,
		      (int)(x+xScale*ROD_MAX_DISTANCE*cos(g_DGRtoRAD(direction+(int)(ROD_ANGLE/2)))),
		      (int)(y+xScale*ROD_MAX_DISTANCE*sin(g_DGRtoRAD(direction+(int)(ROD_ANGLE/2)))));
      }
    }
    else{
      gdk_draw_line(bb_simArea,pen_simArea,(int)(x+radius*cos(g_DGRtoRAD(direction-90))),
	      (int)(y+radius*sin(g_DGRtoRAD(direction-90))),
	      (int)(x+radius*cos(g_DGRtoRAD(direction+90))),
	      (int)(y+radius*sin(g_DGRtoRAD(direction+90))));
    }
    if(robotBody){
      gdk_draw_arc(bb_simArea,
		   pen_simArea,
		   0,
		   x-radius,y-radius,
		   2*radius,2*radius,
		   0,360*64);
    }
  }
  gdk_threads_leave();
}


void gui_drawGripper(int *a, int *b, int layer, int color,int c){
  gdk_threads_enter();
  gdk_gc_set_foreground(pen_simArea,
	 		pal_simArea[(color%GUI_COLORS) + 1]
			);
  if(layer==2){ 
    gdk_draw_line(bg_simArea,pen_simArea,a[0],a[1],a[2],a[3]);
    gdk_draw_line(bg_simArea,pen_simArea,b[0],b[1],b[2],b[3]);
  }
  else{
    gdk_draw_line(bb_simArea,pen_simArea,a[0],a[1],a[2],a[3]);
    gdk_draw_line(bb_simArea,pen_simArea,b[0],b[1],b[2],b[3]);
    //   gdk_draw_line(bb_simArea,pen_simArea,a[0],a[1],b[0],b[1]);
    if(c>2){
      gdk_draw_line(bb_simArea,pen_simArea,a[4],a[5],b[4],b[5]);
      gdk_draw_line(bb_simArea,pen_simArea,a[4],a[5],a[6],a[7]);
      gdk_draw_line(bb_simArea,pen_simArea,b[4],b[5],b[6],b[7]);
      gdk_draw_line(bb_simArea,pen_simArea,a[6],a[7],b[6],b[7]);
    }
  }
  gdk_threads_leave();
  
}

void gui_clear(){
  gdk_threads_enter();
  gdk_gc_set_foreground(pen_simArea,
			pal_simArea[GUI_WHITE]
			);
  gdk_draw_rectangle(bb_simArea,
                     pen_simArea,
                     1,
                     1,1,
                     sim_area_x_size,sim_area_y_size);
  gdk_draw_rectangle(bg_simArea,
                     pen_simArea,
                     1,
                     1,1,
                     sim_area_x_size,sim_area_y_size);
  gdk_threads_leave();
}


void gui_drawWall(int x1, int y1, int x2, int y2){
  gdk_threads_enter();
  gdk_gc_set_foreground(pen_simArea,
			pal_simArea[GUI_BLACK]
			);
  gdk_draw_line(bg_simArea,pen_simArea,x1,y1,x2,y2);
  gdk_threads_leave();
}

void gui_drawSObst(int x, int y, int radius){
  gdk_threads_enter();
  gdk_gc_set_foreground(pen_simArea,
			pal_simArea[GUI_RED]
			);
  gdk_draw_arc(bb_simArea,
               pen_simArea,
               0,
               x-radius,y-radius,
               2*radius,2*radius,
               0,360*64);
  gdk_threads_leave();
}

void gui_drawObst(int x, int y, int radius){
  gdk_threads_enter();
  gdk_gc_set_foreground(pen_simArea,
			pal_simArea[GUI_RED]
			);
  gdk_draw_arc(bg_simArea,
               pen_simArea,
               0,
               x-radius,y-radius,
               2*radius,2*radius,
               0,360*64);
  gdk_threads_leave();
}

void gui_drawZone(int x, int y, int radius){
  gdk_threads_enter();
  gdk_gc_set_foreground(pen_simArea,
			pal_simArea[GUI_GREEN]
			);
  gdk_draw_arc(bg_simArea,
               pen_simArea,
               0,
               x-radius,y-radius,
               2*radius,2*radius,
               0,360*64);
  gdk_threads_leave();
}

void gui_drawLight(int x, int y, int radius){
  gdk_threads_enter();
  gdk_gc_set_foreground(pen_simArea,
			pal_simArea[GUI_YELLOW]
			);
  gdk_draw_arc(bg_simArea,
               pen_simArea,
               0,
               x-radius,y-radius,
               2*radius,2*radius,
               0,360*64);
  gdk_threads_leave();
}
#endif /* !OPENGL */

void gui_redrawWorld(void){
#ifdef WIN32
  ReleaseSemaphore(simArea_S,1,NULL);
  WaitForSingleObject(simAreaUpdate_S,INFINITE);
#else
  sem_post(&simArea_S);
  sem_wait(&simAreaUpdate_S);
#endif
}

#ifndef OPENGL
void gui_drawBG(){
  gdk_threads_enter();
  gdk_draw_pixmap(bb_simArea,
		  blit_simArea,
		  bg_simArea,
		  0,0,0,0,
		  sim_area_x_size,sim_area_y_size);
  gdk_threads_leave();
}
#ifdef HAVE_IMLIB

void gui_snapshot(GtkWidget *widget, gpointer data){
  char filename[256];
  char times[256];
  static gint snap=0;

  tm *timep;
  time_t t;
  t=time(NULL);
  timep = localtime(&t);
  if(strftime(times, 256,"%A_%b_%d_%T_" ,timep)>0){
    g_snprintf(filename,256,"%s%d.jpg",times,snap);
    gui_save_pixmap((GdkPixmap*)bb_simArea,filename);
    printf("Saved %s\n",filename);
    snap++;
  }
}

void gui_save_pixmap(GdkPixmap *pixmap, char *filename){
  gint w,h;
  GdkImlibImage *dest;

  g_return_if_fail (pixmap != NULL);

  if(strlen(filename)>0){
    w = sim_area_x_size;
    h = sim_area_y_size;
    dest = gdk_imlib_create_image_from_drawable((GdkWindow*)pixmap,
						NULL,
						0,0,
						w,h);
    gdk_imlib_save_image(dest, filename, NULL);
    gdk_imlib_destroy_image(dest);
  }
}
#endif
#endif
/* gui_window stuff */

/*   Simple primitives for drawing to the screen */
static struct yWindow *_windowList = 0;

void gui_on_expose_event(GtkWidget *w,
			 GdkEventExpose *event,
			 gpointer window){
  yWindow *win;
  win = (yWindow*)window;
  g_assert(win != NULL);
  gdk_draw_pixmap(GTK_WIDGET(win->da)->window,
		  win->pen,
		  win->bb,
		  0,0,
		  0,0,
		  -1,-1);
}

yWindow *gui_window_new(gint width, gint height,const gchar *title){
  yWindow *cur;
  GtkWidget *box;
  static gint boxId=0;
  gchar nbox[10];
  g_return_val_if_fail((width > 0 && height > 0),NULL);
  if(!_windowList){
    _windowList = (yWindow*) g_malloc(sizeof(yWindow));
    g_assert(_windowList != NULL);
    _windowList->next = NULL;
    cur = _windowList;
  }
  else{
    cur = _windowList;
    while(cur->next)
      cur = cur->next;
    /* cur->next points at last window */
    cur->next = (yWindow*)g_malloc(sizeof(yWindow));
    g_assert(cur->next != NULL);
    cur = cur->next;
    cur->next = NULL;
  }
  cur->w = width;
  cur->h = height;
  cur->bb = NULL;

  gdk_threads_enter();
  cur->window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(cur->window),title);
  gtk_window_set_policy(GTK_WINDOW(cur->window),
			FALSE,
			FALSE,
			TRUE);

  box = gtk_hbox_new(TRUE,0);
  gtk_widget_ref(box);
  gtk_container_add(GTK_CONTAINER(cur->window),box);
  g_snprintf(nbox,10,"hbox%d",boxId++);
  gtk_object_set_data_full(GTK_OBJECT(cur->window),
			   nbox,
			   box,
			   (GtkDestroyNotify)gtk_widget_unref);
  gtk_widget_show(box);

  cur->da = GTK_DRAWING_AREA(gtk_drawing_area_new());
  gtk_widget_ref(GTK_WIDGET(cur->da));
  gtk_drawing_area_size(cur->da,
			width,height);
  gtk_object_set_data_full(GTK_OBJECT(cur->window),
			   title,
			   cur->da,
			   (GtkDestroyNotify)gtk_widget_unref);
  gtk_box_pack_start(GTK_BOX(box),
		     GTK_WIDGET(cur->da),
		     TRUE,
		     TRUE,
		     0);
  gtk_signal_connect(GTK_OBJECT(cur->da),
		     "expose_event",
		     GTK_SIGNAL_FUNC(gui_on_expose_event),
		     (gpointer)cur
		     );
  gtk_widget_show(GTK_WIDGET(cur->da));
  gtk_widget_show(cur->window);
  cur->bb = gdk_pixmap_new(GTK_WIDGET(cur->da)->window,
			   width,height,
			   -1
			   );
  cur->bb = gdk_pixmap_ref(cur->bb);
  cur->cm = gdk_window_get_colormap(GTK_WIDGET(cur->da)->window);
  cur->palette = (GdkColor**) g_malloc(sizeof(GdkColor*)*256);
 for(int i=0; i < 256; i++){
    cur->palette[i] = (GdkColor*)g_malloc(sizeof(GdkColor));
    if(i < 6){
    cur->palette[i]->red   = pal[i][0];
    cur->palette[i]->green = pal[i][1];
    cur->palette[i]->blue  = pal[i][2];
    }
    else{
      cur->palette[i]->red = (guint)(65536.0 * cos(i/double(63.0)*M_PI/3));
      cur->palette[i]->green = (guint)(65536.0 * sin(i/double(63.0)*M_PI/3));
      cur->palette[i]->blue = 0;
    }
    gdk_colormap_alloc_color(cur->cm,
			     cur->palette[i],
			     1, /* writeable ->  private */
  			     1);/* bestmatch */
  }
  cur->pen = gdk_gc_new((GdkWindow*)cur->bb);
  cur->pen = gdk_gc_ref(cur->pen);
  gdk_gc_set_foreground(cur->pen,
			cur->palette[255]);

  gdk_threads_leave();
  return(cur);
}


void gui_window_palette_change(yWindow *win,
			       gint color,
			       guint red,
			       guint green,
			       guint blue){
  g_assert(color > -1 && color < 256);
  win->palette[color]->red = red;
  win->palette[color]->green = green;
  win->palette[color]->blue = blue;
  gdk_threads_enter();
  gdk_colormap_alloc_color(win->cm,
			   win->palette[color],
			   1,
			   1);
  gdk_threads_leave();
}
void gui_window_set_color(yWindow *win,
			  gint color){
  GUI_UPDATE(
  g_assert(color > -1 && color < 256);
  gdk_threads_enter();
  gdk_gc_set_foreground(win->pen,
			win->palette[color]);
  gdk_threads_leave();
  )
}
void gui_window_line(yWindow *win,
		     gint x1, gint y1,
		     gint x2, gint y2){
  GUI_UPDATE(
  gdk_threads_enter();
  gdk_draw_line(win->bb,
		win->pen,
		x1,y1,
		x2,y2);
  gdk_threads_leave();
  )
}

void gui_window_plot(yWindow *win,
		     gint x, gint y){
  GUI_UPDATE(
  gdk_threads_enter();
  gdk_draw_point(win->bb,
		 win->pen,
		 x,y);
  gdk_threads_leave();
  )
}

void gui_window_circle(yWindow *win,
		       gint x, gint y,
		       gint radius,
		       gint filled){
  GUI_UPDATE(
  gdk_threads_enter();
  gdk_draw_arc(win->bb,
	       win->pen,
	       filled,
	       x-radius,y-radius,
	       radius << 1, radius << 1,
	       0, 64 * 360);
  gdk_threads_leave();
  )
}

void gui_window_arc(yWindow *win,
		    gint x, gint y,
		    gint radius,
		    gint filled,
		    gint startAngle,
		    gint endAngle){
  GUI_UPDATE(
  gdk_threads_enter();
  gdk_draw_arc(win->bb,
	       win->pen,
	       filled,
	       x-radius,y-radius,
	       radius << 1, radius << 1,
	       startAngle << 6, endAngle << 6);
  gdk_threads_leave();
  )
}

void gui_window_rectangle(yWindow *win,
			  gint x1, gint y1,
			  gint x2, gint y2,
			  gint filled){
  GUI_UPDATE(
  if(x1 > x2){
    x1 ^= x2;
    x2 ^= x1;
    x1 ^= x2;
  }
  if(y1 > y2){
    y1 ^= y2;
    y2 ^= y1;
    y1 ^= y2;
  }
  gdk_threads_enter();
  gdk_draw_rectangle(win->bb,
		     win->pen,
		     filled,
		     x1,y1,
		     x2-x1,y2-y1);
  gdk_threads_leave();
  )
}

void gui_window_clear(yWindow *win,
		      gint color){
  GUI_UPDATE(
  gui_window_set_color(win,color);
  gui_window_rectangle(win,
		       0,0,
		       win->w,win->h,
		       1);
  )
}

void gui_window_flush(yWindow *win){
  GUI_UPDATE(
  gdk_threads_enter();
  gtk_widget_draw(GTK_WIDGET(win->da),NULL);
  gdk_threads_leave();
  )
}

void gui_window_text(yWindow *win,gint x, gint y,const char *text){
  GUI_UPDATE(
  gdk_threads_enter();
  gdk_draw_text(win->bb,
		defaultFont,
		win->pen,
		x,y,
		text,
		strlen(text));
  gdk_threads_leave();
  )
}
