/*
  Optann, a Khepera simulator including a separate GA and ANN 
  (Genetic Algoritm, Artificial Neural Net).
  Copyright (C) 2000  Johan Carlsson (johanc@ida.his.se)
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 */
#ifndef SIM_H
#define SIM_H

#ifdef WIN32
#include <Windows.h>
extern HANDLE gui_run;
extern HANDLE gui_step;
extern HANDLE gui_ready;
#else
#include <semaphore.h>
extern sem_t gui_run;
extern sem_t gui_step;
extern sem_t gui_ready;
#endif

extern int ind;            /* running Individ    */
extern int gen;            /* running Generation */
extern int epo;            /* running Epoch      */
extern int run;            /* running Step (interaction steps between the robot and the world */
#ifdef OPENGL
extern class Environ *world;
#endif

void sim_shutdown();
void sim_saveweights();

#endif /* SIM_H*/
